(***********************************

      KolibriOS  API  Emulator

************************************)

//{$DEFINE DEBUG_OUTPUT}

Library KEm;

//{$APPTYPE CONSOLE}

Uses
  Windows, Messages, CommDlg, ShellAPI;

{$LINK unpacker.obj}
Procedure UnPack(Const Src; Var Dst); StdCall; External;

{$LINK dtext.obj}
Procedure dtext; External;

{$LINK dnumber.obj}
Procedure display_number; External;

{$LINK loaddll.obj}
Function  loaddll(MemPtr: Pointer): Pointer; External;

Function Printf(Format: PChar): Integer; CDecl; VarArgs; External 'msvcrt.dll' name 'printf';
Function SPrintf(Buffer, Format: PChar): Integer; CDecl; VarArgs; External 'msvcrt.dll' name 'sprintf';
Function MemCmp(Const S1, S2; N: Dword): Integer; CDecl; External 'msvcrt.dll' name 'memcmp';
Function MemCpy(Var Dst; Const Src; N: Dword): Pointer; CDecl; External 'msvcrt.dll' name 'memcpy';
Function StrCpy(Var Dst; Const Src): PChar; CDecl; External 'msvcrt.dll' name 'strcpy';
Function StrNCpy(Var Dst; Const Src; Count: Dword): PChar; CDecl; External 'msvcrt.dll' name 'strncpy';
Function StrCat(Var Dst; Const Src): PChar; CDecl; External 'msvcrt.dll' name 'strcat';
Function StrLen(Const Src): Integer; CDecl; External 'msvcrt.dll' name 'strlen';
Function a2i(Const S: PChar): Integer; CDecl; External 'msvcrt.dll' name 'atoi';
Function GetCh: Integer; CDecl; External 'msvcrt.dll' name '_getch';
Function NtAllocateVirtualMemory(ProcessHandle: THandle; BaseAddress: PPChar; ZeroBits: Dword; RegionSize: PDword; AllocationType: Dword; Protect: Dword): Pointer; StdCall; External 'ntdll';
//Function NtFreeVirtualMemory(ProcessHandle: THandle; BaseAddress: PPChar; RegionSize: PDword; FreeType: Dword): Dword; StdCall; External 'ntdll';

Type
  AppHeader = Packed Record
    Signature:  Packed Array [0..7] Of Char;
    Version:    Dword;
    EntryPoint: Dword;
    EndImage:   Dword;
    Memory:     Dword;
    StackTop:   Dword;
    CmdLine:    Dword;
    FilePath:   Dword;
  End;

  PAppHeader = ^AppHeader;

  TPackedFile = Packed Record
    Signature:    Packed Array [0..3] Of Char; (* 'KPCK' *)
    UnpackedSize: Dword;                       (* size of unpacked data*)
    PackMethod:   Dword;                       (* LZMA, CallTrick, NoCallTrick*)
    PackedData:   Packed Array [0..0] Of Char;
  End;

  PPackedFile = ^TPackedFile;

  TSystemTime = Packed Record
    Hours:   Byte;
    Minutes: Byte;
    Seconds: Byte;
    Zero:    Byte;
  End;

  TSystemDate = Packed Record
    Year:  Byte;
    Month: Byte;
    Day:   Byte;
    Zero:  Byte;
  End;

  TKeyboardInputMode = (kmASCII, kmSCAN);

  TKeyboardInputFlag = (kfCode, kfEmpty, kfHotKey);

  TKeyboardInput = Packed Record
    Flag: TKeyboardInputFlag;
    Code: Byte;
    Case TKeyboardInputMode Of
      kmASCII: (Scan: Byte);
      kmSCAN:  (
                Case TKeyboardInputFlag Of
                  kfCode:   ();
                  kfHotKey: (Control: Word);
               );
  End;

  TButtonInput = Packed Record
    MouseButton: Byte;
    ID:          Word;
    HiID:        Byte;
  End;

  TPoint = Packed Record
    Y: SmallInt;
    X: SmallInt;
  End;

  TSize = Packed Record
    Height: Word;
    Width:  Word;
  End;

  TBox = Packed Record
    Left:   LongInt;
    Top:    LongInt;
    Width:  Dword;
    Height: Dword;
  End;

  TKernelVersion = Packed Record
    A, B, C, D: Byte;
    reserved:   Byte;
    Revision:   Dword;
  End;

  PKernelVersion = ^TKernelVersion;

  TAppData = Packed Record
  //.................
    Caption:      PChar;
    EventMask:    Dword;
    ClientBox:    TBox;
    KeyboardMode: TKeyboardInputMode;
  //.................
  End;

  TThreadInfo = Packed Record
    CpuUsage:     Dword;
    WinStackPos:  Word;
    reserved0:    Word;
    reserved1:    Word;
    Name:         Packed Array[0..10] Of Char;
    reserved2:    Byte;
    MemAddress:   Dword;
    MemUsage:     Dword;
    Identifier:   Dword;
    Window:       TBox;
    ThreadState:  Word;
    reserved3:    Word;
    Client:       TBox;
    WindowState:  Byte;
    EventMask:    Dword;
    KeyboardMode: TKeyboardInputMode;
    reserved4:    Packed Array[0..947] Of Byte;
  End;

  PThreadInfo = ^TThreadInfo;

  TStandardColors = Packed Record
    Frames:         Dword;
    Grab:           Dword;
    Work3DDark:     Dword;
    Work3DLight:    Dword;
    GrabText:       Dword;
    Work:           Dword;
    WorkButton:     Dword;
    WorkButtonText: Dword;
    WorkText:       Dword;
    WorkGraph:      Dword;
  End;

  PStandardColors = ^TStandardColors;

  TFileDate = Packed Record
    Day:   Byte;
    Month: Byte;
    Year:  Word;
  End;

  TFileTime = Packed Record
    Seconds: Byte;
    Minutes: Byte;
    Hours:   Byte;
    Zero:    Byte;
  End;

  TFileAttributes = Packed Record
    Attributes:   Dword;
    Flags:        Dword;
    CreationTime: TFileTime;
    CreationDate: TFileDate;
    AccessTime:   TFileTime;
    AccessDate:   TFileDate;
    ModifyTime:   TFileTime;
    ModifyDate:   TFileDate;
    SizeLo:       Dword;
    SizeHi:       Dword;
  End;

  PFileAttributes = ^TFileAttributes;

  TFileInformation = Packed Record
    FileAttributes: TFileAttributes;
    FileName:       Packed Array[0..255] Of Char;
    reserved:       Packed Array[0..7] Of Byte;
  End;

  PFileInformation = ^TFileInformation;

  TFolderInformation = Packed Record
    Version:         Dword;
    BlockCount:      Dword;
    FileCount:       Dword;
    reserved:        Packed Array[0..19] Of Byte;
    FileInformation: Packed Array[0..0] Of TFileInformation;
  End;

  PFolderInformation = ^TFolderInformation;

  TFileInfoBlock = Packed Record
    FuncNumber: Dword;
    LoPos:      Dword;
    HiPos:      Dword;
    Count:      Dword;
    Buffer:     Pointer;
    ZeroByte:   Byte;
    Case Byte Of
      0: (Path: Pointer);
      1: ();
  End;

  PFileInfoBlock = ^TFileInfoBlock;

Const
  (* for Windows.HeapAlloc *)
  HEAP_ZERO_MEMORY = 8;

 (* Events *)
  REDRAW_EVENT         = 1;
  KEY_EVENT            = 2;
  BUTTON_EVENT         = 3;
  BACKGROUND_EVENT     = 5;
  MOUSE_EVENT          = 6;
  IPC_EVENT            = 7;
  NETWORK_EVENT        = 8;
  DEBUG_EVENT          = 9;

 (* Event Mask Constants *)
  EM_REDRAW            = $001;
  EM_KEY               = $002;
  EM_BUTTON            = $004;
  EM_BACKGROUND        = $010;
  EM_MOUSE             = $020;
  EM_IPC               = $040;
  EM_NETWORK           = $080;
  EM_DEBUG             = $100;

  DEFAULT_EVENT_MASK   = EM_REDRAW + EM_KEY + EM_BUTTON;

  DEFAULT_KEYBOARD_MODE = kmASCII;

  CURRENT_DIRECTORY_LEN = 256; // without terminating zero

Var
  BaseAddress:      PChar;
  RegionSize:       Dword;
  hFile:            Dword;
  FileName:         PChar;
  FileLength:       Dword;
  BytesRead:        Dword;
  PFileBuffer:      PAppHeader = Pointer(0);
  eip:              Dword;
  tmpPtr:           Pointer;
  AppData:          TAppData;
  //StandardColors: TStandardColors;
  hWindow:          Windows.HWND;
  hDC:              Windows.HDC;
  PaintStruct:      Windows.TPaintStruct;
  OpenFile:         CommDlg.TOpenFilename;
  _display_width:   Dword;
  fontSmoothing:    Byte = 2;
  PressedKey:       Packed Record
                      VirtKey: LongInt;
                      Case Byte Of
                        0: (lParam: LPARAM);
                        1: (Count: Word;
                            Scan: Byte;
                            State: Byte);
                    End;
  CurrentDirectory: Array[0..CURRENT_DIRECTORY_LEN] Of Char = '/rd/1';

Const
  BORDER_SIZE = 5;
  SKIN_HEIGHT = 15; // just for testing, it should be taken from the skin file

(* Window styles *)
  WS_SKINNED_FIXED     =  $4000000;
  WS_SKINNED_SIZABLE   =  $3000000;
  WS_FIXED             =  $0000000;
  WS_SIZABLE           =  $2000000;
  WS_FILL_TRANSPARENT  = $40000000;
  WS_FILL_GRADIENT     = $80000000;
  WS_COORD_CLIENT      = $20000000;
  WS_CAPTION           = $10000000;

(* KeyboardLayout flags *)
  KBL_NORMAL           = 1;
  KBL_SHIFT            = 2;
  KBL_ALT              = 3;

  DRAW_LINE_INVERT     = $01000000;
  
Var WindowStyle: Dword = WS_SKINNED_SIZABLE; // just for testing, WindowStyle can have another value

// keep this function be modifying eax only
Function rgb2bgr(Const RGB: Dword): Dword;
//Begin
//  TRGBQuad(Result).rgbBlue     := TRGBQuad(RGB).rgbRed;
//  TRGBQuad(Result).rgbGreen    := TRGBQuad(RGB).rgbGreen;
//  TRGBQuad(Result).rgbRed      := TRGBQuad(RGB).rgbBlue;
//  TRGBQuad(Result).rgbReserved := 0;
Asm
  shl eax, 8
  bswap eax
End;
(******************************************************************************)
Procedure CheckRegistry;
Var
  hKey: Windows.HKEY;
  hRegeditKey: Windows.HKEY;  
  WindowsDirectory, RegeditPath: Array [0..127] Of Char;
Begin
  If Windows.RegOpenKey(HKEY_LOCAL_MACHINE, 'Software\KEm(KolibriOS API Emulator)\Partitions', hKey) <> 0 Then Begin
    Windows.RegCreateKey(HKEY_LOCAL_MACHINE, 'Software\KEm(KolibriOS API Emulator)\Partitions', hKey);
    Windows.RegSetValueEx(hKey, '/rd/1', 0, REG_SZ, Nil, 0);
    Windows.RegSetValueEx(hKey, '/sys', 0, REG_SZ, Nil, 0);
    Windows.RegOpenKey(HKEY_CURRENT_USER, 'Software\Microsoft\Windows\CurrentVersion\Applets\Regedit', hRegeditKey);
    Windows.RegSetValueEx(hRegeditKey, 'LastKey', 0, REG_SZ, PChar('HKEY_LOCAL_MACHINE\Software\KEm(KolibriOS API Emulator)\Partitions'), 67);
    Windows.RegCloseKey(hRegeditKey);
    Windows.GetWindowsDirectory(WindowsDirectory, 127);
    SPrintf(RegeditPath, '%s\%s', WindowsDirectory, 'regedit.exe');
    ShellAPI.ShellExecute(0, Nil, RegeditPath, Nil, Nil, SW_SHOWNORMAL);
    Windows.MessageBox(0, 'Please set the partition paths in the registry'#10'"HKEY_LOCAL_MACHINE\Software\KEm(KolibriOS API Emulator)\Partitions"'#10'to continue correctly working.', '', MB_SYSTEMMODAL);
  End;
  Windows.RegCloseKey(hKey);
End;
(******************************************************************************)
Function GetWindowsPath(KOSPath: PChar; WinPath: PChar): Boolean;
Var
  hKey: Windows.HKEY;
  Index: Dword;
  ValueName: Array[0..127] Of Char;
  ValueLen: Dword;
  DataType: Dword;
  Data: Array[0..127] Of Byte;
  DataLen: Dword;
Begin
  Windows.RegOpenKey(HKEY_LOCAL_MACHINE, 'Software\KEm(KolibriOS API Emulator)\Partitions', hKey);
  ValueLen := 127; DataLen := 127;
  Index := 0;
  While Windows.RegEnumValue(hKey, Index, ValueName, ValueLen, Nil, @DataType, @Data, @DataLen) = 0 Do Begin
    If MemCmp(ValueName, KOSPath^, ValueLen - 1) = 0 Then Begin
      MemCpy(WinPath^, Data, DataLen);
      StrCat(WinPath^, Pointer(Dword(KOSPath) + ValueLen)^);
      Windows.RegCloseKey(hKey);
      Result := True;
      Exit;
    End;
    ValueLen := 127; DataLen := 127;
    Inc(Index);
  End;
  Windows.RegCloseKey(hKey);
  Result := False;
End;
(******************************************************************************)
Function GetKolibriOSPath(WinPath: PChar; KOSPath: PChar): Boolean;
Var
  hKey: Windows.HKEY;
  Index: Dword;
  ValueName: Array[0..127] Of Char;
  ValueLen: Dword;
  DataType: Dword;
  Data: Array[0..127] Of Byte;
  DataLen: Dword;
  i, StrLenKOSPath: Dword;
Begin
  Windows.RegOpenKey(HKEY_LOCAL_MACHINE, 'Software\KEm(KolibriOS API Emulator)\Partitions', hKey);
  ValueLen := 127; DataLen := 127;
  Index := 0;
  While Windows.RegEnumValue(hKey, Index, ValueName, ValueLen, Nil, @DataType, @Data, @DataLen) = 0 Do Begin
    If MemCmp(Data, WinPath^, DataLen - 1) = 0 Then Begin
      MemCpy(KOSPath^, ValueName, ValueLen);
      StrCat(KOSPath^, Pointer(Dword(WinPath) + DataLen - 1)^);
      StrLenKOSPath := StrLen(KOSPath^);
      For i := 0 To StrLenKOSPath Do If KOSPath[i] = '\' Then KOSPath[i] := '/';
      Windows.RegCloseKey(hKey);
      Result := True;
      Exit;
    End;
    ValueLen := 127; DataLen := 127;
    Inc(Index);
  End;
  Windows.RegCloseKey(hKey);
  Result := False;
End;
(******************************************************************************)
// Index - ParamStr index from which Path and Params begin
Procedure SetParamsAndPath(Index: Dword);
Var
  i: Dword;
  KOSPath: Pointer;
Begin
  If PFileBuffer^.FilePath <> 0 Then Begin
    //Printf('PFileBuffer^.FilePath <> 0'#10);
    KOSPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    //Printf('Index = %d'#10, Index);
    //Printf('PChar(ParamStr(Index)) = "%s"'#10, PChar(ParamStr(Index)));
    If GetKolibriOSPath(PChar(ParamStr(Index)), KOSPath) Then
    Begin
      StrCpy(Pointer(PFileBuffer^.FilePath)^, KOSPath^);
      //Printf('KOSPath = "%s"'#10, KOSPath);
    End;
    Windows.HeapFree(GetProcessHeap, 0, KOSPath);
  End;
  If PFileBuffer^.CmdLine <> 0 Then Begin
    //Printf('PFileBuffer^.CmdLine <> 0'#10);
    For i := Index + 1 To ParamCount Do
      SPrintf(PChar(PFileBuffer^.CmdLine), '%s %s', PChar(PFileBuffer^.CmdLine), PChar(ParamStr(i)));
  End;
End;
(******************************************************************************)
Function WindowProc(hwnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LongInt; StdCall;
Var
  CursorPos: Windows.TPoint;
  WindowRect: Windows.TRect;
Begin
  Case uMsg Of
  WM_DESTROY:
    Begin
      Windows.PostQuitMessage(0);
      Result := 0;
    End;
  WM_NCHITTEST:
    Begin
      Result := Windows.DefWindowProc(hwnd, uMsg, wParam, lParam);
      If Result = HTCLIENT Then
      Begin
        Windows.GetCursorPos(CursorPos);
        Windows.ScreenToClient(hwnd, CursorPos);
        If CursorPos.Y < SKIN_HEIGHT Then
          Result := HTCAPTION
        Else If WindowStyle = WS_SKINNED_SIZABLE Then
        Begin
          Windows.GetClientRect(hwnd, WindowRect);
          With WindowRect, CursorPos Do
          Begin
            If X < BORDER_SIZE Then
            Begin
              If Y > Bottom - BORDER_SIZE Then
                Result := HTBOTTOMLEFT
              Else
                Result := HTLEFT;
            End Else
            If X > Right - BORDER_SIZE  Then
            Begin
              If Y > Bottom - BORDER_SIZE Then
                Result := HTBOTTOMRIGHT
              Else
                Result := HTRIGHT;
            End Else
            If Y > Bottom - BORDER_SIZE Then
              Result := HTBOTTOM;
          End;
        End;
      End;
    End;
  Else
    Result := Windows.DefWindowProc(hwnd, uMsg, wParam, lParam);
  End;
End;

(******************************************************************************)
Procedure Sleep(Time: Dword);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('Sleep(Time:%d)'#10, Time);
{$ENDIF}
  Windows.Sleep(Time * 10);
End;
(******************************************************************************)
Procedure DrawImage(Const Image; X, Y: Integer; Width, Height: Dword);
  Procedure ConvBMP24To32(Src, Dst: Pointer; Size: Dword);
  {     ->EAX     Pointer to source       }
  {       EDX     Pointer to destination  }
  {       ECX     Width, Height           }
  Asm
          push  esi
          push  edi
          mov   esi, Src
          mov   edi, Dst
          movzx eax, cx
          shr   ecx, 16
          mul   ecx
          mov   ecx, eax
          xor   eax, eax
  @@next:
          movsw
          movsb
          stosb
          loop  @@next
          pop   edi
          pop   esi
  End;
Var
  BMPInfo: BITMAPINFO;
  tmpBytes: Pointer;
  Padding: Boolean;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DrawImage(Image:$%08x, X:%d, Y:%d, Width:%u, Height:%u)'#10, Pointer(Image), X, Y, Width, Height);
{$ENDIF}
   Padding := Width Mod 4 <> 0;
   With BMPInfo.bmiHeader Do Begin
     biSize          := SizeOf(BMPInfo.bmiHeader);
     biWidth         := Width;
     biHeight        := -Height;
     If Padding Then (* use 32-bit cause it always is dword-padded *)
       biBitCount    := 32
     Else
       biBitCount    := 24;
     biCompression   := BI_RGB;
     biPlanes        := 1;
     biSizeImage     := 0;
     biXPelsPerMeter := 0;
     biYPelsPerMeter := 0;
     biClrUsed       := 0;
     biClrImportant  := 0;
     If Padding Then
     Begin
       tmpBytes := Windows.HeapAlloc(GetProcessHeap, 8, Width * Height * 4);
       ConvBMP24To32(Pointer(Image), tmpBytes, Width Shl 16 Or Height);
       Windows.SetDIBitsToDevice(hDC, X, Y, Width, Height, 0, 0, 0, Height, tmpBytes, BMPInfo, DIB_RGB_COLORS);
       Windows.HeapFree(GetProcessHeap, 0, tmpBytes);
     End
     Else
       Windows.SetDIBitsToDevice(hDC, X, Y, Width, Height, 0, 0, 0, Height, Pointer(Image), BMPInfo, DIB_RGB_COLORS);
   End;
End;
(******************************************************************************)
Procedure ThreadTerminate;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('ThreadTerminate'#10);
{$ENDIF}
  Windows.ExitThread(0);
End;
(******************************************************************************)
Procedure DrawRectangle(X, Y: Integer; Width, Height: Dword; Color: Dword);
Var
  Rect: Windows.TRect;
  hBrush: Windows.HBRUSH;
  //hDC: Windows.HDC;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DrawRectangle(X:%d, Y:%d, Width:%d, Height:%d, Color:$%x)'#10, X, Y, Width, Height, Color);
{$ENDIF}
  With Rect Do Begin Left := X; Top := Y; Right := X + LongInt(Width); Bottom := Y + LongInt(Height); End;
  hBrush := Windows.CreateSolidBrush(rgb2bgr(Color));
  //hDC := Windows.GetDC(hWindow);
  Windows.FillRect(hDC, Rect, hBrush);
  Windows.DeleteObject(hBrush);
  //Windows.ReleaseDC(hWindow, hDC);
End;
(******************************************************************************)
Procedure SetPixel(X, Y: Integer; Color: Dword);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('SetPixel(X:%d, Y:%d, Color:$%x)'#10, X, Y, Color);
{$ENDIF}
  Windows.SetPixel(hDC, X, Y, rgb2bgr(Color))
End;
(******************************************************************************)
Function WaitEvent: Dword;
Var
  Msg: Windows.TMsg;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('WaitEvent'#10);
{$ENDIF}
  If (hWindow = 0) And (EM_REDRAW And AppData.EventMask <> 0) Then
    Windows.PostMessage (hWindow, WM_PAINT, 0, 0);
  While True Do
  Begin
    If Windows.GetMessage(Msg, 0, 0, 0) = False Then
      Windows.ExitThread(0);
    Windows.TranslateMessage(Msg);
    Windows.DispatchMessage(Msg);
    Case Msg.Message Of
      WM_PAINT:
        Begin
          If (EM_REDRAW And AppData.EventMask <> 0) Then
          Begin
            Result := REDRAW_EVENT;
            Exit;
          End;
        End;
      WM_MOUSEMOVE..WM_MOUSEWHEEL,
      WM_NCMOUSEMOVE..WM_NCMBUTTONUP:
        Begin
          If (EM_MOUSE And AppData.EventMask <> 0) Then
          Begin
            Result := MOUSE_EVENT;
            Exit;
          End;
        End;
      WM_KEYDOWN, WM_SYSKEYDOWN,
      WM_KEYUP, WM_SYSKEYUP:
        Begin
          If (EM_KEY And AppData.EventMask <> 0) Then
          Begin
            PressedKey.VirtKey := Msg.wParam;
            PressedKey.lParam := Msg.lParam;
// in SCAN mode all keys are sent but in ASCII mode not all
            Case AppData.KeyboardMode Of
              kmSCAN:
                Begin
                  Result := KEY_EVENT;
                  Exit;
                End;
              kmASCII:
                Begin
                  Case PressedKey.VirtKey Of
                    VK_SHIFT, VK_CONTROL, VK_MENU, VK_CAPITAL,
                    VK_SCROLL, VK_NUMLOCK, VK_SNAPSHOT, VK_PAUSE:
                    Else
                      Begin
                        (* in ASCII mode we need only KEYDOWN *)
                        If Not Boolean(PressedKey.State And $80) Then
                        Begin
                          Result := KEY_EVENT;
                          Exit;
                        End;
                      End;
                  End;
                End;
            End;
          End;
        End;
    End;
  End;
End;
(******************************************************************************)
Function CheckEvent: Dword;
Var
  Msg: Windows.TMsg;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('CheckEvent'#10);
{$ENDIF}
  If (hWindow = 0) And (EM_REDRAW And AppData.EventMask <> 0) Then
    Windows.PostMessage (hWindow, WM_PAINT, 0, 0);
  If Windows.PeekMessage(Msg, 0, 0, 0, PM_REMOVE) <> False Then Begin
    Windows.TranslateMessage(Msg);
    Windows.DispatchMessage(Msg);
    Case Msg.Message Of
      WM_PAINT:
        Begin
          If (EM_REDRAW And AppData.EventMask <> 0) Then
            Result := REDRAW_EVENT
          Else
            Result := 0;
        End;
      WM_MOUSEMOVE..WM_MOUSEWHEEL,
      WM_NCMOUSEMOVE..WM_NCMBUTTONUP:
        Begin
          If (EM_MOUSE And AppData.EventMask <> 0) Then
            Result := MOUSE_EVENT
          Else
            Result := 0;
        End;
      WM_KEYDOWN, WM_SYSKEYDOWN,
      WM_KEYUP, WM_SYSKEYUP:
        Begin
          If (EM_KEY And AppData.EventMask <> 0) Then
          Begin
            PressedKey.VirtKey := Msg.wParam;
            PressedKey.lParam := Msg.lParam;
// in SCAN mode all keys are sent but in ASCII mode not all
            Case AppData.KeyboardMode Of
              kmSCAN:
                Begin
                  Result := KEY_EVENT;
                End;
              kmASCII:
                Begin
                  Case PressedKey.VirtKey Of
                    VK_SHIFT, VK_CONTROL, VK_MENU, VK_CAPITAL,
                    VK_SCROLL, VK_NUMLOCK, VK_SNAPSHOT, VK_PAUSE:
                      Result := 0;
                    Else
                      (* in ASCII mode we need only KEYDOWN *)
                      If Not Boolean(PressedKey.State And $80) Then
                        Result := KEY_EVENT
                      Else
                        Result := 0;
                  End;
                End;
              Else
                Result := 0; // actually this unnecessary, cause there is only SCAN\ASCII
            End;
          End
          Else
            Result := 0;
        End;
      WM_QUIT:
        Begin
          Result := 0; // just for prevent compiler warning
          Windows.ExitThread(0);
        End;
      Else
        Begin
          Result := 0;
        End;
    End;
  End
  Else
    Result := 0;
End;
(******************************************************************************)
Function  WaitEventByTime(Time: Dword): Dword;
Var
  Msg: Windows.TMsg;
  TickCount: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('WaitEventByTime(Time:%d)'#10, Time);
{$ENDIF}
  If (hWindow = 0) And (EM_REDRAW And AppData.EventMask <> 0) Then
    Windows.PostMessage (hWindow, WM_PAINT, 0, 0);
  TickCount := Windows.GetTickCount;
  Repeat
    If Windows.PeekMessage(Msg, 0, 0, 0, PM_REMOVE) <> False Then Begin
      Windows.TranslateMessage(Msg);
      Windows.DispatchMessage(Msg);
      Case Msg.Message Of
        WM_PAINT:
          Begin
            If (EM_REDRAW And AppData.EventMask <> 0) Then
            Begin
              Result := REDRAW_EVENT;
              Exit;
            End;
          End;
        WM_MOUSEMOVE..WM_MOUSEWHEEL,
        WM_NCMOUSEMOVE..WM_NCMBUTTONUP:
          Begin
            If (EM_MOUSE And AppData.EventMask <> 0) Then
            Begin
              Result := MOUSE_EVENT;
              Exit;
            End;
          End;
        WM_KEYDOWN, WM_SYSKEYDOWN,
        WM_KEYUP, WM_SYSKEYUP:
          Begin
            If (EM_KEY And AppData.EventMask <> 0) Then
            Begin
              PressedKey.VirtKey := Msg.wParam;
              PressedKey.lParam := Msg.lParam;
// in SCAN mode all keys are sent but in ASCII mode not all
              Case AppData.KeyboardMode Of
                kmSCAN:
                  Begin
                    Result := KEY_EVENT;
                    Exit;
                  End;
                kmASCII:
                  Begin
                    Case PressedKey.VirtKey Of
                      VK_SHIFT, VK_CONTROL, VK_MENU, VK_CAPITAL,
                      VK_SCROLL, VK_NUMLOCK, VK_SNAPSHOT, VK_PAUSE:
                      Else
                        Begin
                          (* in ASCII mode we need only KEYDOWN *)
                          If Not Boolean(PressedKey.State And $80) Then
                          Begin
                            Result := KEY_EVENT;
                            Exit;
                          End;
                        End;
                    End;
                  End;
              End;
            End;
          End;
        WM_QUIT:
          Begin
            Windows.ExitThread(0);
          End;
      End;
    End;
    Windows.Sleep(1); // Windows.SwitchToThread // Windows.Sleep(0)
  Until Not (Windows.GetTickCount - TickCount < Time * 10);
  Result := 0;
End;
(******************************************************************************)
Function  GetKeyboardLayoutCountry: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetKeyboardLayoutCountry'#10);
{$ENDIF}
    Case Byte(Windows.GetKeyboardLayout(0)) Of
      Windows.LANG_ENGLISH: Result := 1;
      Windows.LANG_FINNISH: Result := 2;
      Windows.LANG_GERMAN:  Result := 3;
      Windows.LANG_RUSSIAN: Result := 4;
    Else
      Result := 0;
    End;
End;
(******************************************************************************)
Function  GetTickCount: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetTickCount'#10);
{$ENDIF}
  Result := Windows.GetTickCount Div 10;
End;
(******************************************************************************)
Function  GetSystemDate: TSystemDate;
Var
  SystemTime: Windows.TSystemTime;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetSystemDate'#10);
{$ENDIF}
  Windows.GetLocalTime(SystemTime);
  With Result, SystemTime Do Begin
    Year  := (((wYear - 2000)  Div 10) Shl 4) Or (wYear  Mod 10);
    Month := ((wMonth          Div 10) Shl 4) Or (wMonth Mod 10);
    Day   := ((wDay            Div 10) Shl 4) Or (wDay   Mod 10);
    Zero  := 0;
  End;
End;
(******************************************************************************)
Procedure SetCurrentDirectory(Path: PChar);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('SetCurrentDirectory(Path:"%s")'#10, Path);
{$ENDIF}
  StrNCpy(CurrentDirectory, Path^, CURRENT_DIRECTORY_LEN);
End;
(******************************************************************************)
Function  GetCurrentDirectory(Buffer: PChar; Count: Dword): Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetCurrentDirectory(Buffer:$%08X, Count:%u)'#10, Buffer, Count);
{$ENDIF}
  Result := StrLen(CurrentDirectory) + 1;
  If Count < Result Then Begin
    MemCpy(Buffer^, CurrentDirectory, Count - 1);
    Buffer[Count - 1] := #0;
  End
  Else
    StrCpy(Buffer^, CurrentDirectory);
End;
(******************************************************************************)
Procedure DrawButton(Left, Top, Right, Bottom: Integer; BackColor, Style, ID: Dword);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DrawButton(Left:%d, Top:%d, Right:%d, Bottom:%d, BackColor:$%x, Style:$%x, ID:$%x)'#10, Left, Top, Right, Bottom, BackColor, Style, ID);
{$ENDIF}
End;
(******************************************************************************)
Procedure DeleteButton(ID: Dword);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DeleteButton(ID:$%x)'#10, ID);
{$ENDIF}
End;
(******************************************************************************)
Function  GetThreadInfo(Slot: Dword; Buffer: PThreadInfo): Dword;
Var
  WRect: TRect;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetThreadInfo(Slot:$%x, Buffer:$%08x)'#10, Slot, Buffer);
{$ENDIF}
  With Buffer^ Do Begin
    Case Slot Of
      $ffffffff:
        Begin
          Windows.GetWindowRect(hWindow, WRect);
          //CpuUsage     := ;
          //WinStackPos  := ;
          reserved0    := 0;
          reserved1    := 0;
          //Name         := ;
          reserved2    := 0;
          MemAddress   := Dword(PFileBuffer);
          //MemUsage     := ;
          //Identifier   := ;
          With Window Do Begin
            Left   := WRect.Left;
            Top    := WRect.Top;
            Width  := WRect.Right  - WRect.Left;
            Height := WRect.Bottom - WRect.Top;
          End;
          //ThreadState  := ;
          reserved3    := 0;
          With Client Do Begin // currently Width, Height returns as Window coordinates, need fix it
            Left   := 0;
            Top    := 0;
            Width  := WRect.Right  - WRect.Left;
            Height := WRect.Bottom - WRect.Top;
          End;
          //WindowState  := ;
          EventMask    := AppData.EventMask;
          KeyboardMode := AppData.KeyboardMode;
        End;
      Else
        Begin

        End;
    End;
  End;
  Result := 0; // actually should be max slot number
End;
(******************************************************************************)
Function  GetSystemTime: TSystemTime;
Var
  SystemTime: Windows.TSystemTime;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetSystemTime'#10);
{$ENDIF}
  Windows.GetLocalTime(SystemTime);
  With Result, SystemTime Do Begin
    Hours   := ((wHour   Div 10) Shl 4) Or (wHour   Mod 10);
    Minutes := ((wMinute Div 10) Shl 4) Or (wMinute Mod 10);
    Seconds := ((wSecond Div 10) Shl 4) Or (wSecond Mod 10);
    Zero    := 0;
  End;
End;

(******************************** Functions needed for DrawText *******************************)
// first 2 functions are not StdCall

Procedure __sys_putpixel;//(X, Y: Integer; Color: Dword);
{     ->EAX     X coordinate       }
{       EBX     Y coordinate       }
{       ECX     xx RR GG BB        }
Asm
  pushad
  and ecx, $00ffffff
  push ecx // Color
  push ebx // Y
  push eax // X
  push hDC
  call Windows.SetPixel
  popad
End;

Function syscall_getpixel: Dword;//(X, Y: Integer): Dword;
{       ->EBX     Y * XSize + X    }
Asm
  push Windows.SM_CXSCREEN
  call Windows.GetSystemMetrics
  mov ecx, eax
  mov eax, ebx
  xor edx, edx
  div ecx
  push eax // Y
  push edx // X
  push hDC
  call Windows.GetPixel
  mov [esp + 32], eax // yes, [esp + 32], see syscall_getpixel in kernel.asm for details
End;

Function kernel_alloc(Bytes: Dword): Pointer; StdCall;
Begin
  Result := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Bytes);;
End;

Function kernel_free(MemPtr: Pointer): Dword; StdCall;
Begin
  Result := Dword(Windows.HeapFree(GetProcessHeap, 0, MemPtr));
End;
(******************************************************)
// keep this function StdCall
Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword); StdCall;
{
dtext:
; edx -> string
; esi = number of characters
; ebx = output coordinates XXXXYYYY h
; ecx = char color and flags flRRGGBB h
; fl = ZBFFRSSS b
; Z=1: edx -> zero terminated string, esi = ?
; B=1: fill background with color eax
; R=1: edi -> user area for redirect
; FF=3: UTF-8 8x16, FF=2: UTF-16LE 8x16
; FF=1: cp866 8x16, FF=0: cp866 6x9
; SSS = (font multiplier)-1
; edi=1: force output
; flag CF=1 means that we deal with asciiz but need to draw no more than esi symbols
}
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DrawText(X:%d, Y:%d, Text:"%s", ForeColor:$%08x, BackColor:$%08x, Flags:$%08x, Count:%u)'#10, X, Y, Text, ForeColor, BackColor, Flags, Count);
{$ENDIF}
  Asm
    push Windows.SM_CXSCREEN      // procedure dtext uses
    call Windows.GetSystemMetrics // _display_width value
    mov _display_width, eax       //
    pushad
    mov ebx, X
    shl ebx, 16
    or  ebx, Y
    mov eax, ForeColor
    call rgb2bgr
    mov ecx, eax
    or  ecx, Flags
    mov eax, BackColor
    mov edi, eax // R=1: edi -> user area for redirect
    call rgb2bgr
    mov edx, Text
    mov esi, Count
    call dtext
    popad
  End;
End;
(******************************************************************************)
Function  GetKey: TKeyboardInput;
// keymap from data32.inc first 128 values; also should to use keymap_shift and keymap_alt
Const KeyMap: Array[0..127] Of Char = (
   '6',  #27,  '1',  '2', '3', '4', '5',  '6',  '7',  '8',  '9',  '0', '-',  '=',  #8, #9,
   'q',  'w',  'e',  'r', 't', 'y', 'u',  'i',  'o',  'p',  '[',  ']', #13,  '~', 'a', 's',
   'd',  'f',  'g',  'h', 'j', 'k', 'l',  ';',  #39,  #96,   #0,  '\', 'z',  'x', 'c', 'v',
   'b',  'n',  'm',  ',', '.', '/', #0,   '4',  '5',  ' ',  '@',  '2', '3',  '4', '5', '6',
   '7',  '8',  '9',  '0', '1', '2', '3', #180, #178, #184,  '6', #176, '7', #179, '8', #181,
  #177, #183, #185, #182, 'A', 'B', '<',  'D', #255,  'F',  'G',  'H', 'I',  'J', 'K', 'L',
   'M',  'N',  'O',  'P', 'Q', 'R', 'S',  'T',  'U',  'V',  'W',  'X', 'Y',  'Z', 'A', 'B',
   'C',  'D',  'E',  'F', 'G', 'H', 'I',  'J',  'K',  'L',  'M',  'N', 'O',  'P', 'Q', 'R'
  );
  Function GetASCII(VirtKey: LongInt; ScanCode: Byte): Byte;
  Var
    KS: TKeyboardState;
  Begin
    Windows.GetKeyboardState(KS);
  (* if VirtKey isn't translated then return value from KeyMap *)
    If Windows.ToAscii(VirtKey, ScanCode, KS, @Result, 0) = 0 Then
      Result := Byte(KeyMap[ScanCode])
    Else (* convert to 866 codepage *)
      Windows.CharToOemBuff(@Result, @Result, 1);
  End;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetKey'#10);
{$ENDIF}
  Dword(Result) := 0;
  With Result Do Begin
    If PressedKey.VirtKey = 0 Then
      Flag := kfEmpty
    Else Begin
      Case AppData.KeyboardMode Of
        kmSCAN:
          Begin
            {* If Not Extended Key *}
            If Not Boolean(PressedKey.State And 1) Then
              Code := PressedKey.Scan Or (PressedKey.State And $80)
            Else Begin
              Code := $E0;
              PressedKey.State := PressedKey.State And Not 1;
              Windows.PostMessage(hWindow, WM_KEYDOWN, PressedKey.VirtKey, PressedKey.lParam);
            End;
          End;
        kmASCII:
          Begin
            Code := GetASCII(PressedKey.VirtKey, PressedKey.Scan);
            Scan := PressedKey.Scan Or (PressedKey.State And $80);
          End;
      End;
    End;
    PressedKey.VirtKey := 0;
  End;
End;
(******************************************************************************)
Function  GetButton: TButtonInput;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetButton'#10);
{$ENDIF}
End;
(******************************************************************************)
Function  GetCPUClock: Dword;
Var
  hKey: Windows.HKEY;
  Len: Integer;
Begin
  Len := SizeOf(Dword);
  Windows.RegOpenKey(HKEY_LOCAL_MACHINE, 'HARDWARE\DESCRIPTION\System\CentralProcessor\0', hKey);
  Windows.RegQueryValueEx(hKey, '~MHz', Nil, Nil, @Result, @Len);
  Windows.RegCloseKey(hKey);
  Result := Result * 1000000;
End;
(******************************************************************************)
Procedure GetKernelVersion(Buffer: PKernelVersion);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetKernelVersion'#10);
{$ENDIF}
  With Buffer^ Do Begin
    A := 0; B := 7; C := 7; D := 0;
    reserved := 8;
    Revision := 7000;
  End;
End;
(******************************************************************************)
Function  WaitRetrace: Integer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('WaitRetrace'#10);
{$ENDIF}
  Result := 0; // Success
End;
(******************************************************************************)             
Function  CenterMousePointer: Integer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('CenterMousePointer'#10);
{$ENDIF}
  Windows.SetCursorPos(Windows.GetSystemMetrics(SM_CXSCREEN) Shr 1, Windows.GetSystemMetrics(SM_CYSCREEN) Shr 1);
  Result := 0; // Success
End;
(******************************************************************************)
Procedure SetMousePos(X, Y: Integer);    
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('SetMousePos(X:%d, Y:%d)'#10, X, Y);
{$ENDIF}
  Windows.SetCursorPos(X, Y);
End;         
(******************************************************************************)
Procedure BeginDraw;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('BeginDraw'#10);
{$ENDIF}
  //InvalidateRect(hWindow, Nil, True);
  //hDC := Windows.BeginPaint(hWindow, PaintStruct);
  Windows.BeginPaint(hWindow, PaintStruct);
End;
(******************************************************************************)
Procedure EndDraw;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('EndDraw'#10);
{$ENDIF}
  Windows.EndPaint(hWindow, PaintStruct);
End;
(******************************************************************************)
Function  GetScreenMax: TPoint;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetScreenMax'#10);
{$ENDIF}
  With Result Do Begin
    X := Windows.GetSystemMetrics(SM_CXSCREEN) - 1;
    Y := Windows.GetSystemMetrics(SM_CYSCREEN) - 1;
  End;
End;
(******************************************************************************)
Function  FlushFloppyCache(FloppyNumber: Dword): Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('FlushFloppyCache(FloppyNumber:%u)'#10, FloppyNumber);
{$ENDIF}
  Result := 0;
End;
(******************************************************************************)
Function  GetMousePos: TPoint;
Var
  Point: Windows.TPoint;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetMousePos'#10);
{$ENDIF}
  Windows.GetCursorPos(Point);
  With Result Do Begin
    X := Point.X;
    Y := Point.Y;
  End;
End;
(******************************************************************************)
Function  GetWindowMousePos: TPoint;
Var
  Point: Windows.TPoint;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetWindowMousePos'#10);
{$ENDIF}
  Windows.GetCursorPos(Point);
  Windows.ScreenToClient(hWindow, Point);
  With Result Do Begin
    X := Point.X;
    Y := Point.Y;
  End;
End;
(******************************************************************************)
Function  GetMouseButtons: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetMouseButtons'#10);
{$ENDIF}
  Result := Dword(GetAsyncKeyState(VK_LBUTTON) < 0)       Or
            Dword(GetAsyncKeyState(VK_RBUTTON) < 0) Shl 1 Or
            Dword(GetAsyncKeyState(VK_MBUTTON) < 0) Shl 2;
End;
(******************************************************************************)
Procedure DrawLine(X1, Y1, X2, Y2: Integer; Color: Dword);           
Var
  hPen: Windows.HPEN;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DrawLine(X1:%d, Y1:%d, X2:%d, Y2:%d, Color:$%08X)'#10, X1, Y1, X2, Y2, Color);
{$ENDIF}
  If Color And DRAW_LINE_INVERT <> 0 Then
      Windows.SetROP2(hDC, R2_NOT);
  hPen := Windows.CreatePen(PS_SOLID, 1, rgb2bgr(Color));  
  Windows.SelectObject(hDC, hPen);
  Windows.MoveToEx(hDC, X1, Y1, Nil);  
  Windows.LineTo(hDC, X2, Y2);
  Windows.SetPixel(hDC, X2, Y2, rgb2bgr(Color));  
  Windows.DeleteObject(hPen);
  Windows.SetROP2(hDC, R2_COPYPEN);  
End;
(******************************************************************************)
Function  GetPixel(X, Y: Integer): Dword;
Var
  ScreenDC: Windows.HDC;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetPixel(X:%d, Y:%d)'#10, X, Y);
{$ENDIF}
  ScreenDC := Windows.GetDC(0);
  Result := rgb2bgr(Windows.GetPixel(ScreenDC, X, Y));
  Windows.ReleaseDC(0, ScreenDC);
End;
(******************************************************************************)
Procedure GetScreenImage(Var Buffer; X, Y: Integer; Width, Height: Dword);
  Procedure ConvBMP32To24(Src, Dst: Pointer; Size: Dword);
  {     ->EAX     Pointer to source       }
  {       EDX     Pointer to destination  }
  {       ECX     Width, Height           }
  Asm
          push  esi
          push  edi
          mov   esi, Src
          mov   edi, Dst
          movzx eax, cx
          shr   ecx, 16
          mul   ecx
          mov   ecx, eax
  @@next:
          movsw
          movsb
          inc   esi
          loop  @@next
          pop   edi
          pop   esi
  End;
Var
  DIBSection, CompatibleDC, ScreenDC: Dword;
  BMPInfo: BITMAPINFO;
  bBytes: Pointer;
  Padding: Boolean;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetScreenImage(Buffer:$%08x, X:%d, Y:%d, Width:%u, Height:%u)'#10, Pointer(Buffer), X, Y, Width, Height);
{$ENDIF}
   Padding := Width Mod 4 <> 0;
   With BMPInfo.bmiHeader Do Begin
     biSize          := SizeOf(BMPInfo.bmiHeader);
     biWidth         := Width;
     biHeight        := -Height;
     If Padding Then (* use 32-bit cause it always is dword-padded *)
       biBitCount    := 32
     Else
       biBitCount    := 24;
     biCompression   := BI_RGB;
     biPlanes        := 1;
     biSizeImage     := 0;
     biXPelsPerMeter := 0;
     biYPelsPerMeter := 0;
     biClrUsed       := 0;
     biClrImportant  := 0;
     CompatibleDC    := Windows.CreateCompatibleDC(0);
     DIBSection      := Windows.CreateDIBSection(CompatibleDC, BMPInfo, DIB_RGB_COLORS, Pointer(bBytes), 0, 0);
     ScreenDC        := Windows.GetWindowDC(0);
     Windows.SelectObject(CompatibleDC, DIBSection);
     Windows.BitBlt(CompatibleDC, 0, 0, Width, Height, ScreenDC, X, Y, SRCCOPY);
     If Padding Then
       ConvBMP32To24(bBytes, Pointer(Buffer), Width Shl 16 Or Height)
     Else
       MemCpy(Pointer(Buffer)^, bBytes^, Width * Height * 3);
     Windows.DeleteDC(CompatibleDC);
     Windows.ReleaseDC(0, ScreenDC);
     Windows.DeleteObject(DIBSection);
   End;
End;
(******************************************************************************)
Function  GetScreenSize: TSize;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetScreenSize'#10);
{$ENDIF}
  With Result Do Begin
    Width  := Windows.GetSystemMetrics(SM_CXSCREEN);
    Height := Windows.GetSystemMetrics(SM_CYSCREEN);
  End;
End;
(******************************************************************************)
Procedure SetKeyboardInputMode(Mode: TKeyboardInputMode);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('SetKeyboardInputMode(Mode:%u)'#10, Mode);
{$ENDIF}
  AppData.KeyboardMode := Mode;
End;
(******************************************************************************)
Function  GetKeyboardInputMode: TKeyboardInputMode;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetKeyboardInputMode'#10);
{$ENDIF}
  Result := AppData.KeyboardMode;
End;
(******************************************************************************)
Function  GetControlKeyState: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetControlKeyState'#10);
{$ENDIF}
  Result := Dword(GetAsyncKeyState(VK_LSHIFT)   < 0)       Or
            Dword(GetAsyncKeyState(VK_RSHIFT)   < 0) Shl 1 Or
            Dword(GetAsyncKeyState(VK_LCONTROL) < 0) Shl 2 Or
            Dword(GetAsyncKeyState(VK_RCONTROL) < 0) Shl 3 Or
            Dword(GetAsyncKeyState(VK_LMENU)    < 0) Shl 4 Or
            Dword(GetAsyncKeyState(VK_RMENU)    < 0) Shl 5 Or
            Dword(GetKeyState(VK_CAPITAL)       = 1) Shl 6 Or
            Dword(GetKeyState(VK_NUMLOCK)       = 1) Shl 7 Or
            Dword(GetKeyState(VK_SCROLL)        = 1) Shl 8;
End;
(******************************************************************************)
Procedure SetWindowPos(Left, Top, Right, Bottom: Integer);
Var
  WRect: TRect;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('SetWindowPos(Left:%d, Top:%d, Right:%d, Bottom:%d)'#10, Left, Top, Right, Bottom);
{$ENDIF}
  Windows.GetWindowRect(hWindow, WRect);
  If Left   <> -1 Then WRect.Left   := Left;
  If Top    <> -1 Then WRect.Top    := Top;
  If Right  <> -1 Then WRect.Right  := Right;
  If Bottom <> -1 Then WRect.Bottom := Bottom;
  With WRect Do
    MoveWindow(hWindow, Left,	Top,	Right + 1,	Bottom + 1,	True);
End;
(******************************************************************************)
Function  HeapCreate: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('HeapCreate'#10);
{$ENDIF}
// Heap size is equal to total amount of free application memory
  Result := $80000000;
End;
(******************************************************************************)
Function  HeapAllocate(Bytes: Dword): Pointer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('HeapAllocate(Bytes:%u)'#10, Bytes);
{$ENDIF}
  Result := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, Bytes);
End;
(******************************************************************************)
Function  HeapFree(MemPtr: Pointer): Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('HeapFree(MemPtr:$%08x)'#10, MemPtr);
{$ENDIF}
  Result := Dword(Windows.HeapFree(GetProcessHeap, 0, MemPtr));
End;
(******************************************************************************)
Function  LoadLibrary(Path: PChar): Pointer;
Var
  hFile: Dword;
  WinPath, tmpPath: Pointer;
  Buffer, tmpPtr, LoadedFile: Pointer;
  FileLength: Dword;
  BytesRead: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('LoadLibrary(Path:"%s")'#10, Path);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := Nil;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := Nil;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  hFile := Windows.CreateFile(WinPath, GENERIC_READ, FILE_SHARE_READ, Nil, OPEN_EXISTING, 0, 0);
  If hFile <> $ffffffff Then Begin
    FileLength := Windows.GetFileSize(hFile, Nil);
    Buffer := Windows.HeapAlloc(GetProcessHeap, 0, FileLength);
    If Not Windows.ReadFile(hFile, Buffer^, FileLength, BytesRead, Nil) Then Begin
      Result := Nil;
      Windows.HeapFree(GetProcessHeap, 0, Buffer);
    End
    Else Begin
      If MemCmp(Buffer^, 'KPCK', 4) = 0 Then
      Begin
        tmpPtr := Windows.HeapAlloc(GetProcessHeap, 0, PPackedFile(Buffer)^.UnpackedSize);
        LoadedFile := tmpPtr;
        UnPack(Buffer^, tmpPtr^);
        Windows.HeapFree(GetProcessHeap, 0, Buffer);
      End
      Else Begin
        LoadedFile := Buffer;
      End;
      Result := loaddll(LoadedFile);
      If Result = Nil Then
        Windows.HeapFree(GetProcessHeap, 0, LoadedFile);
    End;
  End
  Else
    Result := Nil;

  Windows.CloseHandle(hFile);
  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function  HeapReallocate(MemPtr: Pointer; Bytes: Dword): Pointer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('HeapReallocate(MemPtr:$%08x, Bytes:%u)'#10, MemPtr, Bytes);
{$ENDIF}
  Result := Windows.HeapRealloc(GetProcessHeap, HEAP_ZERO_MEMORY, MemPtr, Bytes);
End;
(******************************************************************************)
Function  LoadFile(Path: PChar; Var Size: Dword): Pointer;
Var
  hFile: Dword;
  WinPath, tmpPath: Pointer;
  Buffer, tmpPtr: Pointer;
  FileLength: Dword;
  BytesRead: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('LoadFile(Path:"%s", Size:$%08x)'#10, Path, Size);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := Nil;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := Nil;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  hFile := Windows.CreateFile(WinPath, GENERIC_READ, FILE_SHARE_READ, Nil, OPEN_EXISTING, 0, 0);
  If hFile <> $ffffffff Then Begin
    //Printf('Created'#10);
    FileLength := Windows.GetFileSize(hFile, Nil);
    //Printf('FileLength = %d'#10, FileLength);
    Buffer := Windows.HeapAlloc(GetProcessHeap, 0, FileLength);
    //Printf('HeapAlloc OK, Buffer = $%08x'#10, Buffer);
    If Not Windows.ReadFile(hFile, Buffer^, FileLength, BytesRead, Nil) Then Begin
      Result := Nil;
      Windows.HeapFree(GetProcessHeap, 0, Buffer);
    End
    Else Begin
      //Printf('FileRead OK, BytesRead = %d'#10, BytesRead);
      If MemCmp(Buffer^, 'KPCK', 4) = 0 Then
      Begin
        //Printf('MemCmp OK'#10);
        //Printf('UnpackedSize = %d'#10, PPackedFile(Buffer)^.UnpackedSize);
//(***)READLN;(***)
        tmpPtr := Windows.HeapAlloc(GetProcessHeap, 0, PPackedFile(Buffer)^.UnpackedSize);
        //Printf('HeapAlloc OK'#10);
        Result := tmpPtr;
        Size := PPackedFile(Buffer)^.UnpackedSize;
        UnPack(Buffer^, tmpPtr^);
        //Printf('UnPack OK'#10);
        Windows.HeapFree(GetProcessHeap, 0, Buffer);
        //Printf('HeapFree OK'#10);
      End
      Else Begin
        Result := Buffer;
        Size := FileLength;
        //Printf('Result = $%08x; Size = %d'#10, Result, Size);
      End;
    End;
  End
  Else
    Result := Nil;

  Windows.CloseHandle(hFile);
  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function ReadFile(Path: PChar; Buffer: Pointer; Count, LoPos, HiPos: Cardinal; Var BytesRead: Dword): Integer;
Type
  QwordRec = Packed Record
  Case Byte Of
    0: (Qword: UInt64);
    1: (LoDword, HiDword: Dword);
  End;
Var
  hFile: Dword;
  tmpHiPos: Dword;
  WinPath, tmpPath: Pointer;
  tmpSize, tmpFilePtr: QwordRec;  
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('ReadFile(Path:"%s", Buffer:$%08x, Count:%u, LoPos:%u, HiPos:%u, BytesRead:$%08x)'#10, Path, Buffer, Count, LoPos, HiPos, BytesRead);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  hFile := Windows.CreateFile(WinPath, GENERIC_READ, FILE_SHARE_READ, Nil, OPEN_EXISTING, 0, 0);
  If hFile <> $ffffffff Then Begin
    //Printf('Created'#10);
    tmpHiPos := HiPos;
    // If successful, the function returns the low-order dword of the new file pointer position
    // If an error occured, the function returns -1 BUT what if position = $ffffffff ????
    If Windows.SetFilePointer(hFile, LoPos, @tmpHiPos, FILE_BEGIN) = $ffffffff Then Begin
      BytesRead := 0;
      Result := 5; // EOF
    End
    Else Begin
        //Printf('FilePointer is set'#10);
      If Not Windows.ReadFile(hFile, Buffer^, Count, BytesRead, Nil) Then
        Result := 11
      Else Begin
        If BytesRead = 0 Then Begin // EOF
           tmpSize.LoDword := Windows.GetFileSize(hFile, @tmpSize.HiDword);    
           tmpFilePtr.LoDword := LoPos; tmpFilePtr.HiDword := HiPos;
           Dec(tmpSize.Qword, tmpFilePtr.Qword);
           BytesRead := tmpSize.LoDword;
           Result := 5;
        End
        Else
          //Printf('FileRead OK'#10);
          Result := 0;
      End;
    End;
  End
  Else
    Result := 11;

  Windows.CloseHandle(hFile);
  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function ReadFolder(Path: PChar; Buffer: Pointer; Count, Start, Flags: Cardinal; Var BlocksRead: Dword): Integer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('ReadFolder(Path:"%s", Buffer:$%08x, Count:%u, Start:%u, Flags:$%08x, BlocksRead:$%08x)'#10, Path, Buffer, Count, Start, Flags, BlocksRead);
{$ENDIF}
// not implemented yet
  Result := 11;
End;
(******************************************************************************)
Function CreateFile(Path: PChar; Buffer: Pointer; Count: Cardinal; Var BytesWritten: Dword): Integer;
Var
  hFile: Dword;
  WinPath, tmpPath: Pointer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('CreateFile(Path:"%s", Buffer:$%08x, Count:%u, BytesWritten:$%08x)'#10, Path, Buffer, Count, BytesWritten);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  hFile := Windows.CreateFile(WinPath, GENERIC_WRITE, 0, Nil, CREATE_ALWAYS, 0, 0);
  If hFile <> $ffffffff Then Begin
    //Printf('Created'#10);
    If Not Windows.WriteFile(hFile, Buffer^, Count, BytesWritten, Nil) Then
      Result := 11
    Else Begin
      //Printf('FileWrite OK'#10);
      Result := 0;
    End;
  End
  Else
    Result := 11;

  Windows.CloseHandle(hFile);
  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function WriteFile(Path: PChar; Buffer: Pointer; Count, LoPos, HiPos: Cardinal; Var BytesWritten: Dword): Integer;
Var
  hFile: Dword;
  tmpHiPos: Dword;
  WinPath, tmpPath: Pointer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('WriteFile(Path:"%s", Buffer:$%08x, Count:%u, LoPos:%u, HiPos:%u, BytesWritten:$%08x)'#10, Path, Buffer, Count, LoPos, HiPos, BytesWritten);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  hFile := Windows.CreateFile(WinPath, GENERIC_WRITE, 0, Nil, OPEN_EXISTING, 0, 0);
  If hFile <> $ffffffff Then Begin
    //Printf('Created'#10);
    tmpHiPos := HiPos;
    // If successful, the function returns the low-order dword of the new file pointer position
    // If an error occured, the function returns -1 BUT what if position = $ffffffff ????
    If Windows.SetFilePointer(hFile, LoPos, @tmpHiPos, FILE_BEGIN) <> $ffffffff Then ;
      //Printf('FilePointer is set'#10);
    If Not Windows.WriteFile(hFile, Buffer^, Count, BytesWritten, Nil) Then
      Result := 11
    Else Begin
      //Printf('FileWrite OK'#10);
      Result := 0;
    End;
  End
  Else
    Result := 11;

  Windows.CloseHandle(hFile);
  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function ResizeFile(Path: PChar; LoSize, HiSize: Cardinal): Integer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('ResizeFile(Path:"%s", LoSize:%u, HiSize:%u)'#10, Path, LoSize, HiSize);
{$ENDIF}
// not implemented
  Result := 11;
End;
(******************************************************************************)
Function GetFileAttributes(Path: PChar; Buffer: PFileAttributes): Integer;
Var
  hFile: Dword;
  WinPath, tmpPath: Pointer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetFileAttributes(Path:"%s", Buffer:$%08x)'#10, Path, Buffer);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;
  
  hFile := Windows.CreateFile(WinPath, GENERIC_READ, FILE_SHARE_READ, Nil, OPEN_EXISTING, 0, 0);
  If hFile <> $ffffffff Then Begin
    With Buffer^ Do Begin
      Attributes   := Windows.GetFileAttributes(WinPath);
      SizeLo       := Windows.GetFileSize(hFile, @SizeHi);    
      //Windows.GetFileTime(hFile, ...);
      //CreationTime := ; 
      //CreationDate := ; 
      //AccessTime   := ;   
      //AccessDate   := ;   
      //ModifyTime   := ;   
      //ModifyDate   := ;       
    End;  
    Result := 0;
  End
  Else
    Result := 11;  
    
  Windows.CloseHandle(hFile);  
  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function SetFileAttributes(Path: PChar; Buffer: PFileAttributes): Integer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('SetFileAttributes(Path:"%s", Buffer:$%08x)'#10, Path, Buffer);
{$ENDIF}
// not implemented
  Result := 11;
End;
(******************************************************************************)
Function RunFile(Path, CmdLine: PChar): Integer;
Var
  WinPath, tmpPath: Pointer;
  CommandLine: Pointer;
  SI: STARTUPINFO;
  PI: PROCESS_INFORMATION;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('RunFile(Path:"%s", CmdLine:"%s")'#10, Path, CmdLine);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := -11;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := -11;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  Windows.ZeroMemory(@SI, SizeOf(SI));
  SI.cb := SizeOf(SI);
  Windows.ZeroMemory(@PI, SizeOf(PI));

  CommandLine := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
  SPrintf(CommandLine, '"%s" -base %d "%s" %s', ParamStr(0), PFileBuffer, WinPath, CmdLine);

  If Not Windows.CreateProcess(PChar(ParamStr(0)), CommandLine, Nil, Nil, False, 0, Nil, Nil, SI, PI) Then
    Result := -11
  Else
    Result := 1; // should be ProcessID, 1 - just for testing

  Windows.CloseHandle(PI.hProcess);
  Windows.CloseHandle(PI.hThread);
  Windows.HeapFree(GetProcessHeap, 0, WinPath);
  Windows.HeapFree(GetProcessHeap, 0, CommandLine);
End;
(******************************************************************************)
Function DeleteFile(Path: PChar): Integer;
Var
  WinPath, tmpPath: Pointer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DeleteFile(Path:"%s")'#10, Path);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  If Windows.GetFileAttributes(WinPath) And Windows.FILE_ATTRIBUTE_DIRECTORY = 0 Then Begin
    If Windows.DeleteFile(WinPath) Then
      Result := 0
    Else
      Result := 11;
  End
  Else Begin
    If Windows.RemoveDirectory(WinPath) Then
      Result := 0
    Else
      Result := 11;
  End;

  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function CreateFolder(Path: PChar): Integer;
Var
  WinPath, tmpPath: Pointer;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('CreateFolder(Path:"%s")'#10, Path);
{$ENDIF}
  WinPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
// check for relative path
  If Path[0] = '/' Then Begin (* absolute path *)       
    If Not GetWindowsPath(Path, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
  End
  Else Begin (* relative path *)    
    tmpPath := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, 4096);
    SPrintf(tmpPath, '%s/%s', CurrentDirectory, Path);
    If Not GetWindowsPath(tmpPath, WinPath) Then
    Begin
      Windows.HeapFree(GetProcessHeap, 0, WinPath);
      Result := 11;
      Exit;
    End;
    Windows.HeapFree(GetProcessHeap, 0, tmpPath);
  End;

  If Windows.CreateDirectory(WinPath, Nil) Then
    Result := 0
  Else
    Result := 11;

  Windows.HeapFree(GetProcessHeap, 0, WinPath);
End;
(******************************************************************************)
Function  SetEventMask(Mask: Dword): Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('SetEventMask(Mask:$%x)'#10, Mask);
{$ENDIF}
  Result := AppData.EventMask;
  AppData.EventMask := Mask;
End;
(******************************************************************************)
// keep this function StdCall
Procedure DrawNumber(X, Y: Integer; Number: Dword; ForeColor, BackColor, Params, Flags, Count: Dword); StdCall;
{
  * ebx = parameters of conversion number to text:
    * bl = 0 - ecx contains number
    * bl = 1 - ecx contains pointer to dword/qword-number
    * bh = 0 - display in decimal number system
    * bh = 1 - display in hexadecimal system
    * bh = 2 - display in binary system
    * bits 16-21 = how many digits to display
    * bits 22-29 reserved and must be set to 0
    * bit 30 set = display qword (64-bit) number (must be bl=1)
    * bit 31 set = do not display leading zeroes of the number
  * ecx = number (if bl=0) or pointer (if bl=1)
  * edx = [coordinate on axis x]*65536 + [coordinate on axis y]
  * esi = 0xXXRRGGBB, where
    * RR, GG, BB specify text color
    * XX = 0B0FCSSS (bits):
      * B=1 - fill background (color = edi)
      * F specifies the font:
        0 = 6x9
        1 = 8x16
      * C=0 - draw to the window,
        C=1 - draw to the user buffer (edi)
      * SSS = (size multiplier)-1, so 0 = x1, 7 = x8
}
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DrawNumber(X:%d, Y:%d, Number:%u, ForeColor:$%08x, BackColor:$%08x, Params:$%08x, Flags:$%08x, Count:%u)'#10, X, Y, Number, ForeColor, BackColor, Params, Flags, Count);
{$ENDIF}
  Asm
    push Windows.SM_CXSCREEN      // display_number call to dtext
    call Windows.GetSystemMetrics // which uses _display_width value
    mov _display_width, eax       //
    pushad
    mov ebx, Count
    shl ebx, 16
    or  ebx, Params
    mov ecx, Number
    mov edx, X
    shl edx, 16
    or  edx, Y
    mov eax, ForeColor
    call rgb2bgr
    mov esi, eax
    or  esi, Flags
    mov eax, BackColor
    test esi, $08000000 // if redirect to user buffer
    jnz @@do            // then rgb2bgr unnecessary cause [BackColor] contains pointer
    call rgb2bgr
@@do:
    mov edi, eax
    call display_number
    popad
  End;
End;
(******************************************************************************)
Procedure GetStandardColors(ColorTable: PStandardColors; Size: Dword);
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetStandardColors(ColorTable:$%08x, Size:%u)'#10, ColorTable, Size);
{$ENDIF}
  With ColorTable^ Do Begin
    Frames         := $000000;
    Grab           := $006393;
    Work3DDark     := $B1B1B1;
    Work3DLight    := $000000;
    GrabText       := $FFFFFF;
    Work           := $E8E8E8;
    WorkButton     := $B1B1B1;
    WorkButtonText := $000000;
    WorkText       := $000000;
    WorkGraph      := $000000;
  End;
End;
(******************************************************************************)
Function  GetSkinHeight: Dword;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetSkinHeight'#10);
{$ENDIF}
  Result := SKIN_HEIGHT;
End;
(******************************************************************************)
Function  GetScreenWorkingArea: TRect;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('GetScreenWorkingArea'#10);
{$ENDIF}
// currently without @taskbar sizes, whole screen
  With Result Do Begin
    Left   := 0;
    Top    := 0;
    Right  := Windows.GetSystemMetrics(SM_CXSCREEN) - 1;
    Bottom := Windows.GetSystemMetrics(SM_CYSCREEN) - 1;
  End;
End;
(******************************************************************************)
Procedure DrawWindow(Left, Top, Width, Height: Integer; Caption: PChar; BackColor, WinStyle, CapStyle: Dword);
Var
 WindowClass: Windows.WndClass;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('DrawWindow(Left:%d, Top:%d, Width:%d, Height:%d, Caption:"%s", BackColor:$%x, WinStyle:$%x, CapStyle:$%x)'#10, Left, Top, Width, Height, Caption, BackColor, WinStyle, CapStyle);
{$ENDIF}
  If hWindow = 0 Then
  Begin
    With WindowClass Do
    Begin
      Style         := CS_HREDRAW + CS_VREDRAW;
      lpfnWndProc   := @WindowProc;
      cbClsExtra    := 0;
      cbWndExtra    := 0;
      hInstance     := Windows.GetModuleHandle(Nil);
      hIcon         := Windows.LoadIcon(0, IDI_APPLICATION);
      hCursor       := Windows.LoadCursor(0, IDC_ARROW);
      If WinStyle And WS_FILL_TRANSPARENT = 0 Then
        hbrBackground := Windows.CreateSolidBrush(rgb2bgr(BackColor))
      Else
        hbrBackground := 0;
      lpszMenuName  := Nil;
      lpszClassName := 'WindowClass';
      Windows.RegisterClass(WindowClass);
      (* WS_MAXIMIZEBOX for sizable style it allows to use double click for maximize on window title bar *)
      hWindow := Windows.CreateWindow(lpszClassName, Caption, WS_VISIBLE + WS_POPUP + WS_MAXIMIZEBOX, Left, Top, Width, Height, 0, 0, hInstance, Nil);
    End;
    hDC := Windows.GetDC(hWindow);
  End
  Else Begin
    InvalidateRect(hWindow, Nil, True);
    UpdateWindow(hWindow);
  End;
End;


(******************************************************************************)
Procedure Undefined;
Begin
{$IFDEF DEBUG_OUTPUT}
  Printf('!UNDEFINED!'#10);
{$ENDIF}
End;
(******************************************************************************)
Procedure WaitKey;
Begin
  GetCh;
  Windows.ExitThread(0);
End;
(******************************************************************************)
Function ExceptionHandler(ExceptionRecord: PExceptionRecord; EstablisherFrame: Pointer; ContextRecord: PContext; DispatcherContext: Pointer): Dword; CDecl;
Begin
  Asm
    cld (* need restore direction flag to default (reset) *)
  End;
  With ExceptionRecord^, ContextRecord^ Do
  Begin
{$IFDEF DEBUG_OUTPUT}
    Printf('EIP    = $%08X; ',  Eip);
    Printf('EAX    = $%08X; ',  Eax);
    Printf('EBX    = $%08X; ',  Ebx);
    Printf('ECX    = $%08X'#10, Ecx);
    Printf('EDX    = $%08X; ',  Edx);
    Printf('ESI    = $%08X; ',  Esi);
    Printf('EDI    = $%08X; ',  Edi);
    Printf('EBP    = $%08X'#10, Ebp);
    Printf('ESP    = $%08X; ',  Esp);
    Printf('EFLAGS = $%08X'#10, EFlags);
{$ENDIF}
    If (ExceptionCode = EXCEPTION_ACCESS_VIOLATION) And (Word(ExceptionAddress^) = $40CD) Then
    Begin
      Case Eax Of
$FFFFFFFF: ThreadTerminate;
        0: DrawWindow(Ebx Shr 16, Ecx Shr 16, Ebx And $0000FFFF, Ecx And $0000FFFF, PChar(Edi), Edx And $00FFFFFF, Edx And $FF000000, Esi);
        1: SetPixel(Ebx, Ecx, Edx);
        2: Eax := Dword(GetKey);
        3: Eax := Dword(GetSystemTime);
        4: DrawText(Ebx Shr 16, Ebx And $0000FFFF, Pointer(Edx), Ecx And $00FFFFFF, Edi, Ecx And $FF000000, Esi);
        5: Sleep(Ebx);
        6: Undefined;
        7: DrawImage(Ebx, Edx Shr 16, Edx And $0000FFFF, Ecx Shr 16, Ecx And $0000FFFF);
        8: Case Edx Shr 31 Of
             0: DrawButton(Ebx Shr 16, Ecx Shr 16, Ebx And $0000FFFF, Ecx And $0000FFFF, Esi, Edx And $60000000, Edx And $00FFFFFF);
             1: DeleteButton(Edx And $00FFFFFF);
           End;
        9: Eax := GetThreadInfo(Ecx, Pointer(Ebx));
       10: Eax := WaitEvent;
       11: Eax := CheckEvent;
       12: Case Ebx Of
             1: BeginDraw;
             2: EndDraw;
           Else Undefined;
           End;
       13: DrawRectangle(Ebx Shr 16, Ecx Shr 16, Ebx And $0000FFFF, Ecx And $0000FFFF, Edx);
       14: Eax := Dword(GetScreenMax);
       15: Case Ebx Of
             1: WriteLn('SetBackgroundSize');
             2: WriteLn('SetBackgroundPixel');
             3: WriteLn('DrawBackground');
             4: WriteLn('SetBackgroundDrawMode');
             5: WriteLn('DrawBackgroundImage');
             6: WriteLn('MapBackground');
             7: WriteLn('UnMapBackground');
             8: WriteLn('GetLastDrawnBackgroundRect');
             9: WriteLn('UpdateBackgroundRect');
           Else Undefined;
           End;
       16: Eax := FlushFloppyCache(Ebx);
       17: Eax := Dword(GetButton);
       18: Case Ebx Of
           // .......................................... //
              5: Eax := GetCPUClock;
           // .......................................... //  
             13: GetKernelVersion(PKernelVersion(Ecx));
             14: Eax := WaitRetrace;
             15: Eax := CenterMousePointer;
           // .......................................... //
             19: Case Ecx Of
                 // .......................................... //
                  4: SetMousePos(Edx Shr 16, Edx And $0000FFFF);
                // .......................................... //  
                Else Undefined;
                End;                                 
           // .......................................... //
           Else Undefined;
           End;
// ..................................................... //
       23: Eax := WaitEventByTime(Ebx);
// ..................................................... //
       26: Case Ebx Of
           // .......................................... //
             2: Case Ecx Of
                  KBL_NORMAL, KBL_SHIFT, KBL_ALT: WriteLn('GetKeyboardLayout');
                  9: Eax := GetKeyboardLayoutCountry;
                Else Undefined;
                End;
           // .......................................... //
             9: Eax := GetTickCount;
           // .......................................... //
           Else Undefined;
           End;
// ..................................................... //
       29: Eax := Dword(GetSystemDate);
       30: Case Ebx Of
             1: SetCurrentDirectory(Pointer(Ecx));
             2: Eax := GetCurrentDirectory(Pointer(Ecx), Edx);
           Else Undefined;
           End;
// ..................................................... //
       35: Eax := GetPixel(Ebx Mod Dword(Windows.GetSystemMetrics(SM_CXSCREEN)), Ebx Div Dword(Windows.GetSystemMetrics(SM_CXSCREEN)));
       36: GetScreenImage(Ebx, Edx Shr 16, Edx And $0000FFFF, Ecx Shr 16, Ecx And $0000FFFF);
       37: Case Ebx Of
             0: Eax := Dword(GetMousePos);
             1: Eax := Dword(GetWindowMousePos);
             2: Eax := GetMouseButtons;
           // .......................................... //
           Else Undefined;
           End;       
       38: DrawLine(Ebx Shr 16, Ecx Shr 16, Ebx And $0000FFFF, Ecx And $0000FFFF, Edx);
// ..................................................... //
       40: Eax := SetEventMask(Ebx);
// ..................................................... //
       47: DrawNumber(Edx Shr 16, Edx And $0000FFFF, Ecx, Esi And $00FFFFFF, Edi, Ebx, Esi And $FF000000, Ebx And $3F0000 Shr 16);
       48: Case Ebx Of
           // .......................................... //
             3: GetStandardColors(PStandardColors(Ecx), Edx);
             4: Eax := GetSkinHeight;
             5: With GetScreenWorkingArea Do Begin
                  Eax := Left Shl 16 Or Right;
                  Ebx := Top  Shl 16 Or Bottom;
                End;
           // .......................................... //
           Else Undefined;
           End;
// ..................................................... //
       61: Case Ebx Of
             1: Eax := Dword(GetScreenSize);
           // .......................................... //
           Else Undefined;
           End;
// ..................................................... //
       66: Case Ebx Of
             1: SetKeyboardInputMode(TKeyboardInputMode(Ecx));
             2: Eax := Dword(GetKeyboardInputMode);
             3: Eax := GetControlKeyState;
           // .......................................... //
           Else Undefined;
           End;
       67: SetWindowPos(Ebx, Ecx, Edx, Esi);
       68: Case Ebx Of
           // .......................................... //
             11: Eax := HeapCreate;
             12: Eax := Dword(HeapAllocate(Ecx));
             13: Eax := HeapFree(Pointer(Ecx));
           // .......................................... //
             19: Eax := Dword(LoadLibrary(Pointer(Ecx)));
             20: Eax := Dword(HeapReallocate(Pointer(Edx), Ecx));
             // .......................................... //
             27: Eax := Dword(LoadFile(Pointer(Ecx), Edx));
           // .......................................... //
           Else Undefined;
           End;
// ..................................................... //
       70: With PFileInfoBlock(Ebx)^ Do Begin
             Case FuncNumber Of             
               0: Case ZeroByte Of
                    0: Eax := ReadFile(Path, Buffer, Count, LoPos, HiPos, Ebx);
                  Else 
                       Eax := ReadFile(@ZeroByte, Buffer, Count, LoPos, HiPos, Ebx);
                  End;
               1: Case ZeroByte Of
                    0: Eax := ReadFolder(Path, Buffer, Count, LoPos, HiPos, Ebx);
                  Else 
                       Eax := ReadFolder(@ZeroByte, Buffer, Count, LoPos, HiPos, Ebx);
                  End;                           
               2: Case ZeroByte Of
                    0: Eax := CreateFile(Path, Buffer, Count, Ebx);
                  Else 
                       Eax := CreateFile(@ZeroByte, Buffer, Count, Ebx);
                  End;                           
               3: Case ZeroByte Of
                    0: Eax := WriteFile(Path, Buffer, Count, LoPos, HiPos, Ebx);
                  Else 
                       Eax := WriteFile(@ZeroByte, Buffer, Count, LoPos, HiPos, Ebx);
                  End;                           
               4: Case ZeroByte Of
                    0: Eax := ResizeFile(Path, LoPos, HiPos);
                  Else 
                       Eax := ResizeFile(@ZeroByte, LoPos, HiPos);
                  End;                           
               5: Case ZeroByte Of
                    0: Eax := GetFileAttributes(Path, Buffer);
                  Else 
                       Eax := GetFileAttributes(@ZeroByte, Buffer);
                  End;                           
               6: Case ZeroByte Of
                    0: Eax := SetFileAttributes(Path, Buffer);
                  Else 
                       Eax := SetFileAttributes(@ZeroByte, Buffer);
                  End;                           
               7: Case ZeroByte Of
                    0: Eax := RunFile(Path, PChar(HiPos));
                  Else 
                       Eax := RunFile(@ZeroByte, PChar(HiPos));
                  End;                           
               8: Case ZeroByte Of
                    0: Eax := DeleteFile(Path);
                  Else 
                       Eax := DeleteFile(@ZeroByte);
                  End;                           
               9: Case ZeroByte Of
                    0: Eax := CreateFolder(Path);
                  Else 
                       Eax := CreateFolder(@ZeroByte);
                  End;                           
             // .......................................... //
             Else Undefined;
             End;
           End;
// ..................................................... //


//      N: WriteLn('');

      Else Undefined;
      End;
{$IFDEF DEBUG_OUTPUT}
      Printf('--------------------------------------------------------------------------------');
  {$IFDEF DEBUG_OUTPUT_BY_STEP}
      ReadLn;
  {$ENDIF}
{$ENDIF}
      Inc(Eip, SizeOf(Word($40CD)));
      result := 0;
    End
    Else
      result := 1;
  End;
End;
(******************************************************************************)
Procedure Main;
Var
  PathParamsIndex: Dword;
Begin
  //BaseAddress := Pointer($10000); RegionSize  := 0;
  //NtFreeVirtualMemory(GetCurrentProcess, @BaseAddress, @RegionSize, MEM_RELEASE);

  PathParamsIndex := 1;
  If ParamCount <> 0 Then Begin
    If ParamStr(1) = '-base' Then Begin
      PFileBuffer := Pointer(a2i(PChar(ParamStr(2))));
      FileName := PChar(ParamStr(3));
      PathParamsIndex := 3;
    End
    Else
      FileName := PChar(ParamStr(1));
  End
  Else Begin
    FileName := Windows.HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, MAX_PATH);
    With OpenFile Do Begin
      lStructSize := SizeOf(TOpenFilename);
      lpstrFile := FileName;
      lpstrFilter := #0#0;
      lpstrTitle := #0;
      nMaxFile := MAX_PATH;
      Flags := OFN_FILEMUSTEXIST + OFN_PATHMUSTEXIST + OFN_HIDEREADONLY;
      If CommDlg.GetOpenFileName(OpenFile) Then
        ShellAPI.ShellExecute(0, Nil, PChar(ParamStr(0)), PChar('"' + lpstrFile + '"'), Nil, SW_SHOWNORMAL);
    End;
    Windows.ExitProcess(0);
  End;

  (* allocate memory in 0..64K region *)
  BaseAddress := Pointer(1); RegionSize  := 1024 * 64 - 1;
  NtAllocateVirtualMemory(GetCurrentProcess, @BaseAddress, 0, @RegionSize, MEM_COMMIT Or MEM_RESERVE, PAGE_EXECUTE_READWRITE);

  //Windows.ZeroMemory(PFileBuffer, 65472 * 1024);
  
  hFile := Windows.CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, Nil, OPEN_EXISTING, 0, 0);
  If hFile <> $ffffffff Then
  Begin
    FileLength := Windows.GetFileSize(hFile, Nil);
    If Not Windows.ReadFile(hFile, PFileBuffer^, FileLength, BytesRead, Nil) Then
    Begin
      Printf('ReadFile error.'#10);
      WaitKey;
    End
    Else
    Begin
      If MemCmp(PFileBuffer^.Signature, 'MENUET01', 8) <> 0 Then
        If MemCmp(PFileBuffer^.Signature, 'KPCK', 4) = 0 Then
        Begin
          tmpPtr := Windows.HeapAlloc(GetProcessHeap, 0, FileLength);
          MemCpy(tmpPtr^, PFileBuffer^, FileLength);
          UnPack(tmpPtr^, PFileBuffer^);
          Windows.HeapFree(GetProcessHeap, 0, tmpPtr);
          If MemCmp(PFileBuffer^.Signature, 'MENUET01', 8) <> 0 Then
          Begin
            Printf('Not KolibriOS executable.'#10);
            WaitKey;
          End;
        End
        Else
        Begin
          Printf('Not KolibriOS executable.'#10);
          WaitKey;
        End;
    End;
  End
  Else
  Begin
    Printf('Can not open file.'#10);
    WaitKey;
  End;
  Windows.CloseHandle(hFile);
  With PFileBuffer^ Do
  Begin
    Write ('Signature  = ',         Signature, #10);
    Printf('Version    = $%08X'#10, Version);
    Printf('EntryPoint = $%08X'#10, EntryPoint);
    Printf('EndImage   = $%08X'#10, EndImage);
    Printf('Memory     = $%08X'#10, Memory);
    Printf('StackTop   = $%08X'#10, StackTop);
    Printf('CmdLine    = $%08X'#10, CmdLine);
    Printf('FilePath   = $%08X'#10, FilePath);
    Printf(#10);
    eip := EntryPoint;
  End;
  Printf('Executable file was loaded successfully.'#10#10);
  CheckRegistry;
  SetParamsAndPath(PathParamsIndex);
  Printf('FilePath   = "%s"'#10, PFileBuffer.FilePath);
  Printf('CmdLine    = "%s"'#10, PFileBuffer.CmdLine);
  Printf(#10);
  AppData.EventMask := DEFAULT_EVENT_MASK;
  AppData.KeyboardMode := DEFAULT_KEYBOARD_MODE;
  Asm
  (* set our exception handler *)
    push Offset ExceptionHandler
    push Dword Ptr fs:[0]
    mov  fs:[0], esp
  (* set registers and flags by default *)
    xor eax, eax
    xor ebx, ebx
    xor ecx, ecx
    xor edx, edx
    xor esi, esi
    xor edi, edi
    xor ebp, ebp
    push 0; popfd
  (* goto entry point *)
    jmp  eip
  End;
End;
Exports
  Main;
End.